#!/usr/bin/python

'''Mail Antivir Gate Library
   version 0.2beta
   (c) 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>

This program is a email antivir gate for postfix.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

'''

from config import *
import os,sys,string,re
import pwd,grp,socket,traceback
import time,tempfile # for creatembox
import cStringIO

from avlib import *
from clamav import *
from spamassassin import *

TRUE=1
FALSE=0

R_OK=FALSE
R_FAIL=TRUE

S_OK=1
S_TEMPFAIL=2
S_REJECT='MAIL REJECTED'
S_DROP='MAIL DROPPED'
S_FAIL=5

RECV_SMTP=0
RECV_HEADER=1
RECV_BODY=2

ROOT_PATH=''

class mail_class:
  header=''
  data=''

mail=mail_class()

def ctime():
    return time.time()

def dochroot(user,group,newroot):
    global ROOT_PATH
    uid=pwd.getpwnam(user)[2]
    gid=grp.getgrnam(group)[2]
    if (os.getuid()==0 & os.getgid()==0):
      os.chroot(newroot)
      os.setreuid(uid,gid)
    else:
      ROOT_PATH=newroot
      debug(0,"WARNING! Can't do chroot, permission denied!")

class smtp:
  f=FALSE
  bufsize=10240
  def send(self,s):
    self.conn.send(s)

class smtps(smtp):
  HELO=''
  FROM=''
  TO=[]
  RECV=RECV_SMTP
  def __init__(self,conn):
    self.conn=conn
    self.f=conn.makefile('rw',self.bufsize)
    self.temp=''
    conn.send("220 localhost SMTP agserver\r\n")
    self.t0=ctime()
    self.line=0
    self.mheader=cStringIO.StringIO()
    self.mdata=cStringIO.StringIO()
  def send_ok(self,r="Ok"):
    self.send("250 "+r+"\r\n")
  def recv(self):
    global mail
    line=self.f.readline()
    if not line: return 1
    if self.RECV: # receiving data or header
      if ((self.RECV==RECV_HEADER) & ((line=='\r\n') | (line=='\n'))):
        debug(3,"SMTPS: HEADER DONE")
        self.mdata.write(line)
        self.RECV=RECV_BODY
      elif (line=='.\r\n') | (line=='.\n'):
        debug(3,"SMTPS: BODY DONE")
        self.mheader.flush()
        mail.header=self.mheader.getvalue()
        self.mheader.close()
        self.mdata.flush()
        mail.data=mail.header+self.mdata.getvalue()
        self.mdata.close()
        if len(mail.data)==len(mail.header):
          debug(0,"SMTPS: No header?")
          mail.header=''
        self.RECV=RECV_SMTP
        (v,virname)=checkvir(self.FROM,self.TO)
        if ((v==S_OK) | (v==S_FAIL)):
          debug(1,"SMTPS: OKFAIL: ",string.rstrip(virname))
          self.send(virname)
        elif v==S_REJECT:
          debug(1,"SMTPS: REJECT: ","550 Content rejected - VIRUS ",virname)
          self.send("550 Content rejected - VIRUS "+str(virname)+"\r\n")
        elif v==S_DROP:
          debug(1,"SMTPS: ","DROP: 250 mail dropped, VIRUS ",virname)
          self.send("250 mail dropped, VIRUS "+str(virname)+"\r\n")
        else: # S_TEMPFAIL
          debug(1,"SMTPS: ","TEMPFAIL: 451 Temporarily failed: ",virname)
          self.send("451 Temporarily failed: "+str(virname)+"\r\n")
        debug(2,"SMTPS: Total time: ",[[ctime()-self.t0]])
      else:
        if self.RECV==RECV_HEADER:
          self.mheader.write(line)
        else:
          self.mdata.write(line)
    else:
      debug(2,'SMTPS: '+string.rstrip(line))
      mailfrom=re.search('^MAIL *FROM:(.*)$',line,re.IGNORECASE)
      rcptto=re.search('^RCPT *TO:(.*)$',line,re.IGNORECASE)
      if re.search('^HELO',line,re.IGNORECASE):
        self.HELO=line
        self.send_ok('localhost')
      elif mailfrom:
        self.FROM=mailfrom.group(1)
        self.send_ok()
      elif rcptto:
        self.TO.append(rcptto.group(1))
        self.send_ok()
      elif re.search('^DATA',line,re.IGNORECASE):
        self.RECV=RECV_HEADER
        self.send("354 End data with <CR><LF>.<CR><LF>\r\n")
      elif re.search('^QUIT',line,re.IGNORECASE):
        self.send("221 Bye\r\n")
        return 1
      else:
        self.send("502 Error: command not implemented\r\n")
      return 0

class smtpc(smtp):
  ConnectError='ConnectError'
  WrongReturnCode='WrongReturnCode'
  SendmailError='SendmailError'
  def __init__(self):
    try:
      self.conn=socket.socket(socket.AF_INET,socket.SOCK_STREAM)
      self.conn.connect((SMTP_HOST,SMTP_PORT))
    except socket.error,(ec,es):
      debug(0,"SMTPC: connect error: ",es)
      raise smtpc.ConnectError,"451 SMTP connection refused\r\n"
  def send(self,data,rc):
    if data!='':
      debug(4,"SMTPC>: ",string.rstrip(data))
      self.conn.send(data+"\r\n")
    ret=self.conn.recv(4096)
    debug(4,"SMTPC<: ",string.rstrip(ret))
    if not re.search("^"+rc+" ",ret):
      raise smtpc.WrongReturnCode,string.rstrip(ret)+"!="+rc
    return ret
  def sendmail(self,sender,recipients,ldata='',file=''):
    if file:
      ff=open(file,'r')
      firstline=ff.readline()
      ldata=ff.read()
      ff.close()
    ret="451 SMTP connection error\r\n"
    try:
      self.send('','220')
      self.send("HELO localhost",'250')
      self.send("MAIL FROM:"+sender,'250')
      for rec in recipients:
        self.send("RCPT TO:"+rec,'250')
      self.send("DATA",'354')
      if ldata:
        self.conn.send(ldata)
      else:
        self.conn.send(mail.data)
      debug(4,"SMTPC>: DATA SENT")
      ret=self.send(".","250")
    except smtpc.WrongReturnCode,ret:
      raise smtpc.SendmailError,ret
    try:
      self.send("QUIT","221")
    except smtpc.WrongReturnCode,ret:
      debug(4,"SMTPC: quit error",ret)
    return ret

def creatembox(file):
    try:
      fd=os.open(file,os.O_WRONLY|os.O_CREAT|os.O_EXCL, 0600)
      f=os.fdopen(fd,'w',4096)
      f.write("From local@local"+\
              time.strftime("  %c\n",time.localtime(time.time())))
      f.write(mail.data)
      f.close()
    except os.error,(ec,es):
      debug(0,'creatembox: open error: ',es)
      raise
    except IOError,(ec,es):
      debug(0,'creatembox: ioerror: ',es)
      raise

def tempcleanup(file,s=''):
    try:
      os.unlink(file)
    except OSError,(er,es):
      debug(0,s+": OSError: ",es,file)

def checkvir(sender,recipient):
    smtp_status='000 Unknown'
    try:
      detected,virlist='',[]
      spamstat,spamstr='',''
      t0=ctime()
      if CLAMD:
        debug(3,"AV: Using clamd")
        (detected,virlist)=clamd(mail.data,CLAMD)
        debug(2,"AV: ",[[ctime()-t0]],detected,str(virlist))
        t1=ctime()
      elif CLAMSCAN:
        MBOXFILE=ROOT_PATH+tempfile.mktemp('.sav.mbox')
        creatembox(MBOXFILE)
        debug(3,"AV: Running clamscan")
        (detected,virlist)=clamscanf(MBOXFILE,CLAMSCAN)
        tempcleanup(MBOXFILE,'ClamScan')
        debug(2,"AV: ",[[ctime()-t0]],detected,str(virlist))
        t1=ctime()
      if virlist==[]:
        if SPAMD:
          debug(3,"SA: Using spamd")
          (spamstat,spamstr)=spamd(mail.data,SPAMD,
                               SPAMSTRING,SPAMASSASSIN_MAX_FILE_SIZE)
          debug(2,"SA: ",[[ctime()-t1]],spamstat,spamstr)
        elif SPAMASSASSIN:
          debug(3,"SA: Running spamassassin")
          (spamstat,spamstr)=spamassassin(mail.data,SPAMASSASSIN,\
                               SPAMSTRING,SPAMASSASSIN_MAX_FILE_SIZE)
          debug(2,"SA: ",[[ctime()-t1]],spamstat,spamstr)
      if (virlist==[]) & (spamstat==''):
        # NO VIRUS FOUND
        try:
          smtp_status=smtpc().sendmail(sender,recipient)
        except (smtpc.ConnectError,smtpc.WrongReturnCode,smtpc.SendmailError),es:
          return S_FAIL,es # Any error to deliver the mail
        return S_OK,smtp_status # mail delivered OK
      else: # VIRUS FOUND
        if QUARANTINE_DIR:
          fext=time.strftime("-%Y%m%d-%H%M%S-",time.localtime(time.time()))
          fpath=ROOT_PATH+QUARANTINE_DIR+'/q'
          num=0
          while 1:
            num=num+1
            qfname=fpath+'m'+fext+str(num)
            try:
              fd=os.open(qfname,os.O_WRONLY|os.O_CREAT|os.O_EXCL, 0660)
              break
            except OSError,(ec,es):
              if ec!=17: # already exists
                raise OSError,(ec,es)
          f=os.fdopen(fd,'w',4096)
          f.write(mail.data)
          f.close()
        # SEND REPORT
        if detected=='':
          detected=spamstat
        scanout=''
        for i in virlist:
          scanout=scanout+string.rstrip(i)
        for i in spamstr:
          scanout=scanout+i
        rstat=S_REJECT
        if spamstat:
          rstat=S_DROP
        if re.search(DROP,detected,re.IGNORECASE):
          rstat=S_DROP
        msg=REPORT_MSG % (\
              REPORT_SENDER,REPORT_RECIPIENTS[0],detected,\
              string.rstrip(sender),str(recipient),rstat,qfname,\
              scanout,mail.header)
        try:
          smtpc().sendmail(REPORT_SENDER,REPORT_RECIPIENTS,msg)
        except (smtpc.ConnectError,smtpc.WrongReturnCode,smtpc.SendmailError),es:
          detected=detected+'+MailError'
        return rstat,detected
    except smtpc.SendmailError,es:
      debug(0,"checkvir: SendmailError",es)
      return S_FAIL,es
    except socket.error,(ec,es):
      debug(0,"checkvir: socket.error: ",[[ec]],es)
      debug(0,"checkvir: ",traceback.format_exception(sys.exc_type, sys.exc_value, sys.exc_traceback))
      return S_TEMPFAIL,es
    except IOError,(ec,es):
      debug(0,"checkvir: IOError: ",es)
      debug(0,"checkvir: ",traceback.format_exception(sys.exc_type, sys.exc_value, sys.exc_traceback))
      return S_TEMPFAIL,'IOError'
    except:
      debug(0,"checkvir: ",traceback.format_exception(sys.exc_type, sys.exc_value, sys.exc_traceback))
      return S_TEMPFAIL,'AnyError, see logs'
