# Debugging level, 0=errors only, 1=return status of smtp server,
#   2=smtp server communication, 3=detailed smtp server communication,
#   4=smtp client communication
DEBUG_LEVEL=3

# Where is new root path. For example '/var/spool/vscan'
CHROOT='/home/ondrejj/sh/magate/root'

# User and group, under which this program runs.
USER='ondrejj'
GROUP='ondrejj'

# Buffer size for some of operations.
BUFSIZE=10240

# SMTP server host and port. You must define this smtp server
# in postfix without filtering.
SMTP_HOST='127.0.0.1'
SMTP_PORT=26

# Quarantine dir, in which are stored viruses and spams.
QUARANTINE_DIR='/tmp/quarantine'

# ClamAV settings
CLAMSCAN=['/usr/bin/clamscan','--stdout','--infected','--disable-summary','--mbox','-r']
CLAMD=['localhost',3310]
#CLAMD=['/var/spool/vscan/clamd',0]

# SpamAssassin settings
SPAMASSASSIN=['/usr/bin/spamassassin','-e']
SPAMASSASSIN=[]
SPAMD=['localhost',783]
SPAMD=[]
#SPAMSTRING='^X-Spam-Flag: YES'
SPAMSTRING='^X-Spam-Level: \*\*\*\*\*\*\*\*'
SPAMASSASSIN_MAX_FILE_SIZE=500000

# Bounce emails, which contains viruses or spams.
DROP='(sobig|frethem|lirva|klez|palyh)'

# Send virus reports as ...
REPORT_SENDER="viralert@salstar.sk"
# Send virus reports to ["...","..."]
REPORT_RECIPIENTS=["vir@salstar.sk"]

# MESSAGE SENT AS REPORT
REPORT_MSG='''From: %s
To: %s
Subject: VIRUS %s FOUND!

                             VIRUS FOUND!

---------------------------------------------------------------------
MAIL FROM: %s
RCPT TO: %s
STATUS: %s
QUARANTINED AS: %s
---------------------------------------------------------------------
OUTPUT OF SCANNER:
%s
---------------------------------------------------------------------
HEADER OF MESSAGE:
%s\
---------------------------------------------------------------------
'''
