#!/usr/bin/python

'''
magserver.py 0.2
(c) 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

'''

from config import *
from aglib import *
import signal

def chldexit(sn,stack):
    os.wait()

def main(host,port):
    s=socket.socket(socket.AF_INET,socket.SOCK_STREAM)
    s.setsockopt(socket.SOL_SOCKET,socket.SO_REUSEADDR,1)
    try:
      s.bind((host,port))
      s.listen(2)
    except socket.gaierror,(ec,es):
      debug(0,"SERVER: BIND ERROR: ",es)
      sys.exit(1)
    dochroot(USER,GROUP,CHROOT)
    signal.signal(signal.SIGCHLD,chldexit)
    while 1:
      try:
        conn,addr = s.accept()
        pid=os.fork()
        if pid==0:
          signal.signal(signal.SIGCHLD,signal.SIG_IGN)
          debug(1,"SERVER: Connection from: "+addr[0])
          m=smtps(conn)
          while 1:
            if m.recv(): break
          conn.shutdown(2)
          debug(1,"SERVER: Closing connection.")
          sys.exit(0)
        conn.close()
      except socket.error,(en,es):
        if en==107: # 'Transport endpoint is not connected'
          debug(1,"SERVER: Connection closed by peer.")
          sys.exit(0)
        elif en==32: # 'Broken pipe'
          debug(0,"SERVER: Broken pipe.")
          sys.exit(1)
        elif en!=4:
          debug(0,'SERVER: SocketError: ',es)
          debug(0,traceback.format_exception(sys.exc_type, sys.exc_value, sys.exc_traceback))
          if en==9:
            sys.exit(1)
      except KeyboardInterrupt:
        debug(0,"SERVER: Exiting ...")
        sys.exit(0)

print "agserver started, waiting for connections ..."
host='localhost'
port=10025
if len(sys.argv)>2:
  port=string.atoi(sys.argv[2])
if len(sys.argv)>1:
  host=sys.argv[1]
main(host,port)
